#include "CircularListNode.h"

CircularList* createCircularList()
{
	CircularList* pReturn = NULL;

	pReturn = (CircularList*)malloc(sizeof(CircularList));

	if( pReturn != NULL )
	{
		memset(pReturn, 0, sizeof(CircularList));
	}
	else
	{
		printf("crateCircularList Error! pReturn Ҵ\n");

		return NULL;
	}

	return pReturn;
}

int addCLElement(CircularList* pList, int position, CircularListNode element)
{
	int i = 0;
	int ret = FALSE;

	CircularListNode *pNewNode = NULL;
	CircularListNode *pPreNode = NULL;
	CircularListNode *pLastNode = NULL;

	if( pList != NULL )
	{
		if( position >= 0 && position <= pList->curElementCnt )
		{
			pNewNode = (CircularListNode*)malloc(sizeof(CircularListNode));
			if( pNewNode == NULL )
			{
				printf("addCLElement Error! pNewNode Ҵ\n");

				return ret;
			}

			*pNewNode = element;
			pNewNode->pLink = NULL;

			if(position ==0)
			{
				if( pList->curElementCnt==0 )
				{
					pList->headerNode.pLink = pNewNode;
					pNewNode->pLink = pNewNode;
				}
				else
				{
					pLastNode = pList->headerNode.pLink;
					while(pList->headerNode.pLink != pLastNode->pLink)
					{
						pLastNode = pLastNode->pLink;
					}

					pNewNode->pLink = pList->headerNode.pLink;
					pList->headerNode.pLink = pNewNode;
					pLastNode->pLink = pNewNode;
				}
			}
			else
			{
				pPreNode = &(pList->headerNode);

				for(i=0; i<position; i++)
				{
					pPreNode = pPreNode->pLink;
				}

				pNewNode->pLink = pPreNode->pLink;
				pPreNode->pLink = pNewNode;
			}

			pList->curElementCnt++;
			ret = TRUE;
		}
		else
		{
			printf("addCLElement Error! position(%d) \n", position);
		}
	}

	return ret;
}

int removeCLElement(CircularList* pList, int position)
{
	int i = 0 ;
	int ret = FALSE;

	CircularListNode *pPreNode = NULL;
	CircularListNode *pDelNode = NULL;
	CircularListNode *pLastNode = NULL;

	if( pList != NULL )
	{
		if( position >= 0 && position < pList->curElementCnt )
		{
			if( position == 0 )
			{
				if( pList->curElementCnt == 1 )
				{
					pDelNode= pList->headerNode.pLink;
					pList->headerNode.pLink = NULL;
					free(pDelNode);
				}
				else
				{
					pDelNode = pList->headerNode.pLink;

					pLastNode = pList->headerNode.pLink;
					while(pList->headerNode.pLink != pLastNode->pLink)
					{
						pLastNode = pLastNode->pLink;
					}

					pList->headerNode.pLink = pDelNode->pLink;
					free(pDelNode);
					pLastNode->pLink = pList->headerNode.pLink;
				}
			}
			else
			{
				pPreNode = &(pList->headerNode);

				for(i=0; i<position; i++)
				{
					pPreNode = pPreNode->pLink;
				}

				pDelNode = pPreNode->pLink;

				pPreNode->pLink = pDelNode->pLink;
				free(pDelNode);
			}

			pList->curElementCnt--;
			ret = TRUE;
		}
		else
		{
			printf("removeCLElement Error! position(%d) \n", position);
		}
	}

	return ret;
}

int getCircularListLength(CircularList* pList)
{
	int ret = 0;

	if( pList != NULL )
	{
		ret = pList->curElementCnt;
	}

	return ret;
}

CircularListNode* getCLElement(CircularList* pList, int position)
{
	int i = 0;

	CircularListNode* pReturn = NULL;

	if( pList != NULL )
	{
		if( position >= 0 && position < pList->curElementCnt )
		{
			pReturn = &(pList->headerNode);

			for(i=0; i<=position; i++)
			{
				pReturn = pReturn->pLink;
			}
		}
		else
		{
			printf("getCLElement Error! position(%d) \n", position);
		}
	}

	return pReturn;
}

void displayCircularList(CircularList* pList)
{
	int i = 0;

	if( pList != NULL )
	{
		printf("   : %d \n", pList->curElementCnt);

		for(i=0; i<pList->curElementCnt; i++)
		{
			printf("[%d] : %d \n", i, getCLElement(pList, i)->data);
		}
	}
}

void deleteCircularList(CircularList* pList)
{
	if( pList != NULL )
	{
		clearCircularList(pList);
		free(pList);
	}
}

void clearCircularList(CircularList* pList)
{
	if( pList != NULL )
	{
		while( pList->curElementCnt > 0 )
		{
			removeCLElement(pList, 0);
		}
	}
}
